package bang.pratic.testdb;

import java.util.Observable;
import java.util.Observer;

import bang.pratic.testdb.data.DisplayHelper;
import bang.pratic.testdb.data.dbOp;

import android.os.Bundle;
import android.app.Activity;
import android.content.Context;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends BaseActivity implements Observer {
	private dbOp dbHelper;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		initButton();
		initValue();
		LogSome(DisplayHelper.getDisplayMetrics(this.getApplication()
				.getBaseContext()));

	}

	private void initValue() {
		dbHelper = new dbOp();
		dbHelper.addObserver(this);
	}

	private void initButton() {

		initbtnScalar();
		initbtnGetMetricsInfo();
		initBtnCreateAndOpenDB();
		initBtnAddRecords();
		initBtnDelete();
		initBtnUpdate();
		initBtnQuery();
		initBtnDbClose();

	}

	private void initBtnDbClose() {
		Button btnCloseDB = (Button) this.findViewById(R.id.btnCloseDB);
		btnCloseDB.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				MainActivity.this.dbHelper.CloseDB();
			}
		});

	}

	private void initBtnQuery() {
		Button btnQueryRecords = (Button) this
				.findViewById(R.id.btnQueryRecords);
		btnQueryRecords.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				MainActivity.this.dbHelper.query();
			}
		});

	}

	private void initBtnUpdate() {
		Button btnChangeRecords = (Button) this
				.findViewById(R.id.btnChangeRecords);
		btnChangeRecords.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				MainActivity.this.dbHelper.update();
			}
		});

	}

	private void initBtnDelete() {
		Button btnDeleteRecords = (Button) this
				.findViewById(R.id.btnDeleteRecords);
		btnDeleteRecords.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				MainActivity.this.dbHelper.delete();
			}
		});
	}

	private void initBtnAddRecords() {
		Button btnAddRecords = (Button) this.findViewById(R.id.btnAddRecords);
		btnAddRecords.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				MainActivity.this.dbHelper.insert();
			}
		});
	}

	private void initBtnCreateAndOpenDB() {
		Button btnCreateAndOpenDB = (Button) this
				.findViewById(R.id.btnCreateAndOpenDB);
		btnCreateAndOpenDB.setOnClickListener(new OnClickListener() {
			private final TextView tvMetricsInfo = (TextView) MainActivity.this
					.findViewById(R.id.tvMetricsInfo);

			@Override
			public void onClick(View v) {
				dbHelper.CreateOrOpenDb();
			}
		});
	}

	private void initbtnGetMetricsInfo() {
		Button btnGetMetricsInfo = (Button) this
				.findViewById(R.id.btnGetMetricsInfo);
		btnGetMetricsInfo.setOnClickListener(new OnClickListener() {
			private final TextView tvMetricsInfo = (TextView) MainActivity.this
					.findViewById(R.id.tvMetricsInfo);

			@Override
			public void onClick(View v) {
				tvMetricsInfo.setText(DisplayHelper
						.getDisplayMetrics(MainActivity.this.getApplication()
								.getBaseContext()));
			}
		});
	}

	private void initbtnScalar() {
		Button btnScaler = (Button) this.findViewById(R.id.btnScaler);
		btnScaler.setOnClickListener(new OnClickListener() {
			private final TextView tvMetricsInfo = (TextView) MainActivity.this
					.findViewById(R.id.tvMetricsInfo);

			@Override
			public void onClick(View v) {
				// pxdip
				int iWidthDip = DisplayHelper.pxTodip(DisplayHelper
						.getDisplayMetrics().widthPixels);
				int iHeithDip = DisplayHelper.pxTodip(DisplayHelper
						.getDisplayMetrics().heightPixels);
				StringBuilder sb = new StringBuilder();
				sb.append("ĻĿ(dip):");
				sb.append("" + iWidthDip + "\n");
				sb.append("Ļĸ߶(dip)ǣ");
				sb.append("" + iHeithDip + "\n");
				// dippx
				tvMetricsInfo.setText(sb.toString());
				Log.e(this.getClass().getSimpleName(), sb.toString());
			}

		});
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.activity_main, menu);
		return true;
	}

	@Override
	public void update(Observable observable, Object data) {
		if (data != null) {
			LogSome(String.valueOf(data));
			Toast.makeText(getApplicationContext(), String.valueOf(data),
					Toast.LENGTH_SHORT).show();
		}
	}

}
